您的位置:首页 > 其它

[HDU 3555] Bomb [数位DP]

2016-07-06 16:24 357 查看
Source

2010 ACM-ICPC Multi-University Training Contest(12)

http://acm.hdu.edu.cn/showproblem.php?pid=3555

#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cmath>
#include<cstring>
#define maxn 25
using namespace std;
typedef long long LL;
LL N,n,dp[maxn][3];
//dp[i][j]:i->lenth j->status
int dig[maxn];
//status: 0->no"49" 1->ended with"4" 2->have"49"
int cal()
{
int cnt = 0;
while(n)
{
dig[++cnt]=n%10;
n/=10;
}
dig[cnt+1]=0;
return cnt;
}
LL dfs(int pos,int status,int limit)
{
if(pos<=0)return (status==2);
if(!limit && dp[pos][status]!=-1)return dp[pos][status];
LL ans = 0;
int end = limit?dig[pos]:9;
for(int i=0;i<=end;i++)//enum the end.
{
int new_status = status;
if(status==0&&i==4)new_status = 1;
else if(status==1&&i!=4&&i!=9)new_status = 0;
else if(status==1&&i==9)new_status = 2;
ans+=dfs(pos-1,new_status,limit && i==end);
}
if(!limit)
dp[pos][status]=ans;
return ans;
}
void work()
{
int len = cal();
LL ans = dfs(len,0,1);
printf("%lld\n",ans);
}
int main()
{
scanf("%lld",&N);
while(N--)
{
memset(dp,-1,sizeof(dp));
scanf("%lld",&n);
work();
}
return 0;
}


写法2:

题意:

求0 到n的数中有多少个数字是含有‘49’的!

PS:

数位DP

//dp[i][j]:长度为i的数的第j种状态

//dp[i][0]:长度为i但是不包含49的方案数

//dp[i][1]:长度为i且不含49但是以9开头的数字的方案数

//dp[i][2]:长度为i且包含49的方案数

(转)状态转移如下

dp[i][0] = dp[i-1][0] * 10 - dp[i-1][1]; // not include 49 如果不含49且,在前面可以填上0-9 但是要减去dp[i-1][1] 因为4会和9构成49

dp[i][1] = dp[i-1][0]; // not include 49 but starts with 9 这个直接在不含49的数上填个9就行了

dp[i][2] = dp[i-1][2] * 10 + dp[i-1][1]; // include 49 已经含有49的数可以填0-9,或者9开头的填4

接着就是从高位开始统计

在统计到某一位的时候,加上 dp[i-1][2] * digit[i] 是显然对的,因为这一位可以填 0 - (digit[i]-1)

若这一位之前挨着49,那么加上 dp[i-1][0] * digit[i] 也是显然对的。

若这一位之前没有挨着49,但是digit[i]比4大,那么当这一位填4的时候,就得加上dp[i-1][1]

#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;
typedef __int64 LL;
LL dp[27][3];
int c[27];
//dp[i][j]:长度为i的数的第j种状态
//dp[i][0]:长度为i但是不包含49的方案数
//dp[i][1]:长度为i且不含49但是以9开头的数字的方案数
//dp[i][2]:长度为i且包含49的方案数
void init()
{
memset(dp,0,sizeof(dp));
dp[0][0] = 1;
for(int i = 1; i <= 20; i++)
{
dp[i][0] = dp[i-1][0]*10-dp[i-1][1];
dp[i][1] = dp[i-1][0]*1;
dp[i][2] = dp[i-1][2]*10+dp[i-1][1];
}
}

int cal(LL n)
{
int k = 0;
memset(c,0,sizeof(c));
while(n)
{
c[++k] = n%10;
n/=10;
}
c[k+1] = 0;
return k;
}
void solve(int len, LL n)
{
int flag = 0;//标记是否出现过49
LL ans = 0;
for(int i = len; i >= 1; i--)
{
ans+=c[i]*dp[i-1][2];
if(flag)
{
ans+=c[i]*dp[i-1][0];
}
else if(c[i] > 4)
{
//这一位前面没有挨着49,但c[i]比4大,那么当这一位填4的时候,要加上dp[i-1][1]
ans+=dp[i-1][1];
}
if(c[i+1]==4 && c[i]==9)
{
flag = 1;
}
}
printf("%I64d\n",ans);
}
int main()
{
int t;
LL n;
init();
scanf("%d",&t);
while(t--)
{
scanf("%I64d",&n);
int len = cal(n+1);
solve(len, n);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  dp